%% GENERAL INFORMATION
% Start a few simulations
%
% Author: Piotr Jaglarz (pjaglarz@student.agh.edu.pl)
% Date: 04.2014

function main( num_of_sim, num_of_fail )

if ischar( num_of_sim )
    num_of_sim = str2double( num_of_sim );
    num_of_fail = str2double( num_of_fail );
end

demands = [];
distribution = 'pareto';
load( 'demands' );

%% Clear the environment
close all;
clc;

tic;

matlabpool

load( '../modul_optymalizacyjny/input' );

% czas trwania N*Num = 1000 - 15 sek dla protekcji
N = num_of_sim;             % liczba symulacji
Num = num_of_fail;          % liczba awarii

%demands = round(4*rand(66,1));
d_size = length( d );

total_down = zeros( d_size, N );
number_down = zeros( d_size, N );
wake_time = zeros( length( A ), N );
wake_number = zeros( length( A ), N );
wake_failure = zeros( d_size, N );
simulation_time = zeros( 1, N );
link_load = zeros( length( A ), N );
link_load_backup = zeros( length( A ), N );
Global_cost = zeros( 1, N );
Backup_cost = zeros( d_size, N );
Path_cost = zeros( d_size, N );


parfor i = 1 : N
    
    [ total_down( :, i ), number_down( :, i ), wake_time( :, i ), wake_number( :, i ), wake_failure( :, i ), simulation_time( i ), link_load( :, i ), link_load_backup( :, i ), Global_cost( i ), Backup_cost( :, i ), Path_cost( :, i ) ] = main_simulation( Num, distribution, demands, i );
    
    if mod( i, N / 100 ) == 0
        disp( i );
        %disp( toc / 3600 );
    end
    
end

time = toc / 3600;
display( time );

% Generate simulation id
rng('shuffle');
id = round( 10000 * rand );

name = sprintf( '%s_%s', filename( 1 : end - 4 ), distribution );

load( '../modul_optymalizacyjny/output_NR' );
save( sprintf( 'output/%s_%dx%d_%s_%d.mat', name, N, Num, datestr(now,'yyyy.mm.dd_HH.MM'), id ), 'A', 'd', 'demands', 'total_down', 'number_down', 'wake_time', 'wake_number', 'wake_failure', 'simulation_time', 'link_load', 'link_load_backup', 'Global_cost', 'Backup_cost', 'Path_cost', 'name', 'time' );

matlabpool close

update;
risk2cplex;